;+------------------------------------------------------+
;|	       _/_/_/_/  _/_/      _/_/_/_/		|
;|	     _/        _/    _/  _/			|
;|	     _/        _/    _/  _/			|
;|	       _/_/    _/    _/    _/_/			|
;|	           _/  _/    _/        _/		|
;|	           _/  _/    _/        _/		|
;|	   _/_/_/_/      _/_/  _/_/_/_/    v1.5		|
;+----------->by Joe Wingbermuehle 09-12-1998<----------+
;| See sos.txt for information about SOS.		|
;| Please do not modify this code!			|
;| Visit my home page at:  http://www.usmo.com/~joewing	|
;| Send comments/bugs to:  joewing@usmo.com		|
;+------------------------------------------------------+

	.nolist
	#include	"joeti83.inc"
	.org	$9327	; jump/call offset (where the prog is loaded)

;---------= Variables =---------
storage		=statvars
progloc		=storage+0	; location (2 bytes)
progsize	=storage+2	; program size (2 bytes)
progdes		=storage+4	; pointer to program description (2 bytes)
progname	=storage+6	; name of the program (9 bytes)
number		=storage+15	; number of programs (1 byte)
basicflag	=storage+16	; is the program a BASIC program? (1 byte)
fatmap		=storage+17	; program number/fat location (2*8=16 bytes)
nextprog	=op6		; points to next var in fat (2 bytes)
		; op5 is used as a temporary store for op6 aka nextprog

	.list

;---------= Beginning of SOS! =---------
startofsos:
	im	1
	ld	hl,$8600
	ld	a,h
	ld	(hl),$93
	ld	de,$8601
	ld	b,e
	ld	c,l
	ldir
	ld	i,a
	ld	hl,(curfat)
	ld	a,h
	or	l
	jr	nz,ppstrt
strtpg:	ld	hl,(fat)
ppstrt:	ld	(nextprog),hl
start:	call	rindoff
	call	clrgbuf
	set	7,(iy+20)
	ld	hl,(nextprog)
	ld	(curfat),hl
	xor	a
	ld	(number),a
	ld	bc,0*256+57
	ld	de,94*256+57
	call	dark_line
	ld	hl,fatmap
	ld	bc,8*256+7
dispp:	push	bc
	push	bc
	push	hl
	ld	hl,(nextprog)
	call	findprog
	pop	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	pop	bc
	inc	hl
	jr	nz,nomore
	push	hl
	ld	l,$00
	ld	h,c
	ld	(pencol),hl
	ld	hl,progname
	call	vputs
	ld	hl,number
	inc	(hl)
	ld	a,(hl)
	ld	(running),a
	pop	hl
	pop	bc
	ld	a,c

;-----> Check for 2nd+on and prevent it
	jr	interrupt_end
interrupt_start:
	ex	af,af'
	in	a,(3)
	rra
	jr	nc,on_not_pressed
	res	3,(iy+18)
on_not_pressed:
	jp	$0039
interrupt_end:

	add	a,$07
	ld	c,a
	djnz	dispp
	push	bc
nomore:	pop	bc
	ld	a,(running)
	or	a
	jp	z,exit
	ld	a,(number)
	or	a
	jr	z,strtpg
progsx:	jr	strthl

;---------= Wait for a key press (with APD) =----------
pmain:	call	bufcopy
main:	im	2
	res	4,(iy+9)
	call	getkey
	or	a
	jr	nz,mainCont
	rst	38h
	inc	a
	out	(3),a
	halt
	xor	a
mainCont:
	im	1

;---------= Main loop =---------
	cp	73	; [Y=]
	jr	z,run
	cp	68	; [GRAPH]
	ret	z
	cp	1	; [(right)]
	jr	nz,wrong
	ld	(highlighted),a
	jp	start
wrong:	sub	3	; [(up)]
	jr	z,up
	dec	a	; [(down)]
	jr	nz,main

;---------= Move the highlight =---------
down:	ld	hl,(number)
	ld	a,(highlighted)
	cp	l
	jr	nz,mdown
	xor	a
mdown:	inc	a
mvcomp:	push	af
	call	hilight
	pop	af
	ld	(highlighted),a
strthl:	call	dispdes
	jr	pmain
up:	ld	a,(highlighted)
	dec	a
	jr	nz,mvcomp
	ld	a,(number)
	jr	mvcomp

;---------= Run a program =---------
run:	call	getdata

;-----> Run BASIC
	ld	a,(basicflag)
	or	a
	jr	z,runAsm
	ld	hl,op1
	ld	(hl),$06
	inc	hl
	ld	(hl),'A'
	inc	hl
	ld	(hl),b		; b=0 'cuz of getdata
	call	chksysvar
	ld	hl,30
	add	hl,de
	ld	bc,$0800
	ld	de,progname
rbasicl:
	ld	a,c
	or	a
	jr	nz,notInName
	ld	a,(de)
	or	a
	jr	nz,stillInName
	inc	c
notInName:
	ld	a,$3E
stillInName:
	ld	(hl),a
	inc	hl
	inc	de
	djnz	rbasicl
	call	op1set0
	jp	stox
;-----<

runAsm:	ld	hl,(progloc)	; run asm program
	push	hl		; check for libs (lib support: 81 bytes)
	inc	hl
	inc	hl
	inc	hl
	call	ldhlind
	pop	de
	ld	a,h
	or	l
	jr	z,nolibs
	add	hl,de
	; EOF format for prog using libs:
	;	"LIB",0,0,0,0,0,libnum,vectnum, [$FF if no more]
libll:
	ld	de,op1
	ld	a,$06
	ld	(de),a
	inc	de
	ld	c,8	; b=0 because of getdata way up there!
	ldir
	push	hl
	call	chksysvar
	inc	de
	inc	de
	pop	hl
	jr	nc,libfnd
	ld	hl,(7*7)*256+34
	ld	(pencol),hl
	ld	hl,op1+1
	call	vputs
	call	op5_to_op6
	jp	main
libfnd:	ld	c,(hl)	; get the lib number (mult of 2)
	push	hl
	ex	de,hl
;	ld	b,$00	; chksysvar makes b=0 (or does not change it).
	push	hl
	add	hl,bc
	call	ldhlind
	pop	de
	add	hl,de
	ex	de,hl
	pop	hl
	inc	hl
	ld	c,(hl)	; vector number (mult of 3)
	push	hl
;	ld	b,$00	; ldhlind doesn't mess up b!
	ld	hl,cmdshad+40	; reserve two bytes for a lib variable
	add	hl,bc
	ld	(hl),$C3	; jp xxxx
	inc	hl
	ld	(hl),e
	inc	hl
	ld	(hl),d
	pop	hl
	inc	hl
	ld	a,(hl)
	inc	a		; end of table?
	jr	nz,libll
nolibs:	call	clrgbuf
	call	clrscr
	ld	bc,hookend-hook
	ld	de,cmdshad
	push	de	; save a byte!
	ld	hl,hook
	ldir
	ld	de,(progloc)
	ld	bc,(progsize)
	ld	hl,$9327
	ret	; jp to cmdshad
hook:	push	bc	; start of cmdshad
ex1:	call	cmdshad+swap-hook
	inc	hl
	inc	de
	jr	nz,ex1
	push	de
	push	hl
	call	$9327
	pop	hl
	pop	de
	pop	bc
ex2:	dec	hl
	dec	de
	call	cmdshad+swap-hook
	jr	nz,ex2
	jp	$9327
swap:	push	bc
	ld	b,(hl)
	ld	a,(de)
	ld	(hl),a
	ld	a,b
	ld	(de),a
	pop	bc
	dec	bc
	ld	a,b
	or	c
	ret
hookend:

;---------= Get info on highlighted prog =---------
getdata:
	call	op6_to_op5
	ld	hl,fatmap-2
	ld	bc,(highlighted)
	ld	b,$00
	add	hl,bc
	add	hl,bc
	call	ldhlind

;---------= Detect programs =---------
findprog:
findlp:	push	hl
	ld	a,(hl)
	and	%00011111
	cp	$0D
	jr	z,list
	dec	a	; 1
	jr	z,list
	sub	$04	; 5
	jr	z,chkprg
	dec	a	; 6
	jr	z,chkprg
	pop	de
	ret
chkprg:	dec	hl
	ld	b,(hl)
	dec	hl
	push	hl
	ld	h,(hl)
	ld	l,b
	ld	e,(hl)
	inc	hl
	ld	d,(hl)
	ld	(progsize),de
	inc	hl
	ld	(progloc),hl

;-----> BASIC support
;	xor	a		; already 0
	ld	de,basicflag
	ld	(de),a
	ld	a,(hl)
	cp	$3E		; ':'
	jr	nz,notbasic
	ld	(de),a		; $3E if BASIC
	ld	hl,progname
	jr	basicEnter
notbasic:
;-----<

	inc	hl
	ld	a,(hl)
	cp	$18	; jr xx
	jr	nz,nogood
	dec	hl
	push	hl
	ld	de,$0005
	add	hl,de
	call	ldhlind
	ld	de,-$9327
	add	hl,de
	pop	de
	add	hl,de
basicEnter:
	ld	(progdes),hl
	pop	hl
	dec	hl
	ld	b,(hl)
	ld	de,progname
skprog:	dec	hl
	ld	a,(hl)
	ld	(de),a
	inc	de
	djnz	skprog
	xor	a
	ld	(de),a
	dec	hl
	ld	(nextprog),hl
	pop	de
	ret

nogood:	pop	hl
list:	pop	hl
	dec	hl
	dec	hl
	dec	hl
	ld	b,(hl)
	inc	b
nogdlp:	dec	hl
	djnz	nogdlp
	jr	findlp

;---------= Disp hl in small font =---------
vdisphl:
	call	setxxxxop2
	call	op2_to_op1
	jp	dispop1a

;---------= Get the length of a string =---------
; input: hl->string
; output: hl=length (if less than 60+b*256)
getlen:	ld	c,60
	xor	a
	push	hl
	cpir
	pop	de
	sbc	hl,de
	ret

;---------= Show a description =---------
dispdes:
	call	getdata
	call	op5_to_op6

	ld	hl,gbuf+(7*12)+4	; clear right of screen & draw line
	ld	b,7*8
	ld	de,12-8
clrl1:	ld	(hl),%10000000
	inc	hl
	ld	c,$07
clrl2:	ld	(hl),d
	inc	hl
	dec	c
	jr	nz,clrl2
	add	hl,de
	djnz	clrl1

	set	7,(iy+20)	; display title
	ld	hl,0*256+25
	ld	(pencol),hl
	ld	hl,sostxt
	call	vputs

	ld	de,(7*6)*256+34	; display free memory
	ld	(pencol),de
	call	vputs
	call	memfree
	call	vdisphl

	ld	hl,(7*5)*256+34	; display program size
	ld	(pencol),hl
	ld	hl,size
	call	vputs
	ld	hl,progname
	call	getlen
	ld	de,(progsize)
	add	hl,de
	ld	de,5
	add	hl,de
	call	vdisphl

	ld	hl,(7*1)*256+34	; display description
	ld	(pencol),hl
	ld	hl,(progdes)
	call	getlen
	ld	a,l
	ex	de,hl
	cp	18
	jr	c,short
longer:	push	hl
	rra
	dec	a		; Q: Why did I do this? A: To make SQRXZ appear better.
	ld	e,a
	ld	d,0
	ld	b,d
	ld	c,e
	add	hl,de
	ld	a,' '
	cpir
	pop	de
	sbc	hl,de
	ld	b,l
	ex	de,hl
	call	vputsn
	ld	de,(7*2)*256+34
	ld	(pencol),de
short:	call	vputs
exit:	res	7,(iy+20)

;---------= Highlight a program =---------
hilight:
	ld	hl,(highlighted)
	ld	h,7*12
	call	htimesl
	ld	de,gbuf
	add	hl,de
	ld	c,$07
	ld	de,$0008
hillp1:	ld	b,$04
hillp2:	ld	a,(hl)
	cpl
	ld	(hl),a
	inc	hl
	djnz	hillp2
	add	hl,de
	dec	c
	jr	nz,hillp1
	ret

;---------= Dialog =---------
sostxt:	.db	$08,'0',$08," 1.5Joe W",$00
free:	.db	"Free:",$00
size:	.db	"Size:",$00

;---------= Startup Variables =---------
running:
	.db	$00	; variable must be 0 at startup (SOS is not written back)
highlighted:
	.db	$01
curfat:	.dw	$0000

endofsos:

.end
END